"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  Singletons.setCreate(new _create.CreateImplementation());
  Singletons.setEnvironment(new _environment.EnvironmentImplementation());
  Singletons.setFunctions(new _function.FunctionImplementation());
  Singletons.setJoin(new _join.JoinImplementation());
  Singletons.setLeak(new _leak.LeakImplementation());
  Singletons.setPath(new _paths.PathImplementation());
  Singletons.setProperties(new _properties.PropertiesImplementation());
  Singletons.setTo(new _to.ToImplementation());
  Singletons.setWiden(new _widen.WidenImplementation());
};

var _singletons = require("./singletons.js");

var Singletons = _interopRequireWildcard(_singletons);

var _create = require("./methods/create.js");

var _environment = require("./methods/environment.js");

var _function = require("./methods/function.js");

var _join = require("./methods/join.js");

var _leak = require("./utils/leak.js");

var _paths = require("./utils/paths.js");

var _properties = require("./methods/properties.js");

var _to = require("./methods/to.js");

var _widen = require("./methods/widen.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
//# sourceMappingURL=initialize-singletons.js.map